
import 'package:flutter/material.dart';
import 'package:nirrti/src/custom_components/custom_autocomplete/dropdown_container/view_model.dart';
import 'package:nirrti/src/custom_components/custom_autocomplete/view_model.dart';

mixin ViewMixin {
  render(BuildContext context, DropDownContainerState state) {
    return Container(
      width: state.widget.width ?? 200,
      height: 250,
      decoration: ShapeDecoration(
        color: Colors.white,
        shape: RoundedRectangleBorder(
          side: const BorderSide(
            width: 1.5,
            color: Colors.black26,
          ),
          borderRadius: BorderRadius.circular(12),
        ),
      ),
      child: ListView(
        children: [
          for (AutocompleteOption item in state.widget.optionsList)
          generateSection(context, state, item)
        ],
      )
    );
  }

  Widget generateSection(BuildContext context, DropDownContainerState state, AutocompleteOption option) {
    return SizedBox(
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.center,
        children: [
          InkWell(
            onTap: () {
              state.widget.onClickOption(option);
            },
            child: IgnorePointer(
              child: MouseRegion(
                cursor: SystemMouseCursors.click,
                child: GestureDetector(
                  child: Container(
                    padding: const EdgeInsets.fromLTRB(12, 5, 12, 5),
                    child: Row(
                      children: [
                        Container(
                          width: 40,
                          height: 20,
                          alignment: Alignment.center,
                          child: Text(
                            option.label,
                            style: Theme.of(context).textTheme.bodySmall?.copyWith(
                              color: Colors.black,
                            )
                          ),
                        )
                      ]
                    )
                  ),
                )
              ),
            )
          )
        ],
      )
    );
  }
}